/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ELSE_ = 258,
     IF_ = 259,
     INT_ = 260,
     PRINT_ = 261,
     READ_ = 262,
     RETURN_ = 263,
     WHILE_ = 264,
     ACOR_ = 265,
     ALLA_ = 266,
     APAR_ = 267,
     CCOR_ = 268,
     CLLA_ = 269,
     CPAR_ = 270,
     COMA_ = 271,
     PUNTOCOMA_ = 272,
     CTE_ = 273,
     OPREL_ = 274,
     OPMUL_ = 275,
     OPADD_ = 276,
     OPASIG_ = 277,
     OPINCDEC_ = 278,
     ID_ = 279
   };
#endif
/* Tokens.  */
#define ELSE_ 258
#define IF_ 259
#define INT_ 260
#define PRINT_ 261
#define READ_ 262
#define RETURN_ 263
#define WHILE_ 264
#define ACOR_ 265
#define ALLA_ 266
#define APAR_ 267
#define CCOR_ 268
#define CLLA_ 269
#define CPAR_ 270
#define COMA_ 271
#define PUNTOCOMA_ 272
#define CTE_ 273
#define OPREL_ 274
#define OPMUL_ 275
#define OPADD_ 276
#define OPASIG_ 277
#define OPINCDEC_ 278
#define ID_ 279




/* Copy the first part of user declarations.  */
#line 1 "asin.y"

/*****************************************************************************/
/*****************************************************************************/
/**  Analizador Sintactico-Semantico para MenosC.09                         **/
/**                                                                         **/
/**                     Jose Miguel Benedi, 2009-2010 <jbenedi@dsic.upv.es> **/
/*****************************************************************************/
/*****************************************************************************/
#include <stdio.h>
#include "header.h"


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 14 "asin.y"
{
  char* ident;              /* Para los identificadores                      */
  int   ent;                /* Para constantes enteras                       */
  REFE  ref;                /* Para los no terminales con referencias dobles */
  EXPR  expre;              /* Para los no terminales que son expresiones    */
  int   aux;                /* Para los no terminales con un atributo simple */
}
/* Line 193 of yacc.c.  */
#line 164 "asin-yac.c"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 177 "asin-yac.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   102

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  25
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  34
/* YYNRULES -- Number of rules.  */
#define YYNRULES  58
/* YYNRULES -- Number of states.  */
#define YYNSTATES  113

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   279

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    12,    14,    16,    20,
      27,    28,    32,    33,    40,    41,    43,    46,    47,    53,
      54,    55,    64,    65,    68,    69,    72,    76,    78,    80,
      82,    84,    89,    97,   103,   109,   110,   111,   121,   122,
     123,   131,   133,   137,   139,   143,   145,   149,   151,   153,
     156,   159,   163,   168,   169,   175,   176,   178,   180
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      26,     0,    -1,    -1,    27,    28,    -1,    29,    -1,    28,
      29,    -1,    30,    -1,    31,    -1,     5,    24,    17,    -1,
       5,    24,    10,    18,    13,    17,    -1,    -1,    33,    32,
      38,    -1,    -1,     5,    24,    34,    12,    35,    15,    -1,
      -1,    36,    -1,     5,    24,    -1,    -1,     5,    24,    16,
      37,    36,    -1,    -1,    -1,    39,    11,    41,    40,    42,
       8,    52,    14,    -1,    -1,    41,    30,    -1,    -1,    42,
      43,    -1,    11,    42,    14,    -1,    44,    -1,    45,    -1,
      46,    -1,    49,    -1,    24,    22,    52,    17,    -1,    24,
      10,    52,    13,    22,    52,    17,    -1,     7,    12,    24,
      15,    17,    -1,     6,    12,    52,    15,    17,    -1,    -1,
      -1,     4,    12,    52,    15,    47,    43,    48,     3,    43,
      -1,    -1,    -1,    50,     9,    12,    52,    15,    51,    43,
      -1,    53,    -1,    53,    19,    53,    -1,    54,    -1,    53,
      21,    54,    -1,    55,    -1,    54,    20,    55,    -1,    24,
      -1,    18,    -1,    21,    55,    -1,    23,    55,    -1,    12,
      52,    15,    -1,    24,    10,    52,    13,    -1,    -1,    24,
      12,    56,    57,    15,    -1,    -1,    58,    -1,    52,    -1,
      52,    16,    58,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,    50,    50,    50,    83,    87,    96,   100,   106,   114,
     128,   126,   142,   140,   158,   160,   166,   177,   175,   191,
     200,   191,   237,   239,   242,   244,   248,   249,   250,   251,
     252,   256,   291,   328,   343,   357,   369,   355,   388,   392,
     388,   414,   418,   449,   453,   467,   471,   485,   509,   516,
     532,   545,   549,   571,   569,   606,   608,   614,   625
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ELSE_", "IF_", "INT_", "PRINT_",
  "READ_", "RETURN_", "WHILE_", "ACOR_", "ALLA_", "APAR_", "CCOR_",
  "CLLA_", "CPAR_", "COMA_", "PUNTOCOMA_", "CTE_", "OPREL_", "OPMUL_",
  "OPADD_", "OPASIG_", "OPINCDEC_", "ID_", "$accept", "programa", "@1",
  "lista_declaraciones", "declaracion", "decla_variable", "decla_funcion",
  "@2", "cab_funcion", "@3", "param_formales", "lista_param_form", "@4",
  "bloque", "@5", "@6", "decla_var_locales", "lista_instrucciones",
  "instruccion", "inst_asignacion", "inst_es", "inst_if", "@7", "@8",
  "inst_while", "@9", "@10", "expresion", "exp_simple", "termino",
  "factor", "@11", "param_actuales", "lista_param_act", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    25,    27,    26,    28,    28,    29,    29,    30,    30,
      32,    31,    34,    33,    35,    35,    36,    37,    36,    39,
      40,    38,    41,    41,    42,    42,    43,    43,    43,    43,
      43,    44,    44,    45,    45,    47,    48,    46,    50,    51,
      49,    52,    52,    53,    53,    54,    54,    55,    55,    55,
      55,    55,    55,    56,    55,    57,    57,    58,    58
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     1,     2,     1,     1,     3,     6,
       0,     3,     0,     6,     0,     1,     2,     0,     5,     0,
       0,     8,     0,     2,     0,     2,     3,     1,     1,     1,
       1,     4,     7,     5,     5,     0,     0,     9,     0,     0,
       7,     1,     3,     1,     3,     1,     3,     1,     1,     2,
       2,     3,     4,     0,     5,     0,     1,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     0,     1,     0,     3,     4,     6,     7,    10,
      12,     5,    19,     0,     8,     0,    11,     0,     0,    14,
      22,     0,     0,     0,    15,    20,     9,    16,    13,     0,
      23,    24,    17,     0,    38,     0,     0,     0,     0,     0,
      24,     0,    25,    27,    28,    29,    30,     0,    18,     0,
       0,     0,     0,    48,     0,     0,    47,     0,    41,    43,
      45,    38,     0,     0,     0,     0,     0,     0,     0,    49,
      50,     0,    53,    21,     0,     0,     0,    26,     0,     0,
       0,    35,     0,     0,    51,     0,    55,    42,    44,    46,
       0,    31,     0,    38,    34,    33,    52,    57,     0,    56,
       0,    39,    36,     0,    54,     0,    38,     0,    58,    32,
      40,    38,    37
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     2,     5,     6,     7,     8,    12,     9,    15,
      23,    24,    35,    16,    17,    31,    25,    34,    42,    43,
      44,    45,    93,   107,    46,    47,   106,    97,    58,    59,
      60,    86,    98,    99
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -92
static const yytype_int8 yypact[] =
{
     -92,     5,     1,   -92,   -15,     1,   -92,   -92,   -92,   -92,
      -9,   -92,   -92,    -6,   -92,    15,   -92,    11,    17,    26,
     -92,    23,    19,    29,   -92,    48,   -92,    40,   -92,    34,
     -92,   -92,   -92,    -9,    10,    26,    45,    47,    50,    27,
     -92,    -3,   -92,   -92,   -92,   -92,   -92,    51,   -92,    27,
      27,    39,    27,   -92,    27,    27,    37,    52,    33,    44,
     -92,    22,    27,    27,    53,    54,    55,    56,    57,   -92,
     -92,    27,   -92,   -92,    27,    27,    27,   -92,    60,    58,
      27,   -92,    59,    61,   -92,    64,    27,    46,    44,   -92,
      62,   -92,    65,    31,   -92,   -92,   -92,    63,    66,   -92,
      27,   -92,   -92,    27,   -92,    68,    31,    71,   -92,   -92,
     -92,    31,   -92
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -92,   -92,   -92,   -92,    77,    43,   -92,   -92,   -92,   -92,
     -92,    67,   -92,   -92,   -92,   -92,   -92,    49,   -91,   -92,
     -92,   -92,   -92,   -92,   -92,   -92,   -92,   -39,     9,    12,
     -51,   -92,   -92,   -17
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      57,    13,   102,    69,    70,     3,     4,    62,    14,    10,
      65,    66,    18,    68,    36,   110,    37,    38,    39,    63,
     112,    40,    20,    78,    79,    89,    36,    19,    37,    38,
      21,    22,    85,    40,    41,    36,    77,    37,    38,    52,
      26,    92,    40,    27,    28,    53,    41,    71,    54,    72,
      55,    56,    74,    29,    75,    41,    32,    49,    33,    50,
      64,   105,    51,    67,    76,    80,    73,    75,    30,    81,
      82,    83,    84,    90,   111,    91,    94,    96,    95,   103,
     101,   104,    11,    87,   100,   109,   108,    88,     0,    61,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    48
};

static const yytype_int8 yycheck[] =
{
      39,    10,    93,    54,    55,     0,     5,    10,    17,    24,
      49,    50,    18,    52,     4,   106,     6,     7,     8,    22,
     111,    11,    11,    62,    63,    76,     4,    12,     6,     7,
      13,     5,    71,    11,    24,     4,    14,     6,     7,    12,
      17,    80,    11,    24,    15,    18,    24,    10,    21,    12,
      23,    24,    19,     5,    21,    24,    16,    12,    24,    12,
       9,   100,    12,    24,    20,    12,    14,    21,    25,    15,
      15,    15,    15,    13,     3,    17,    17,    13,    17,    16,
      15,    15,     5,    74,    22,    17,   103,    75,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    35
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    26,    27,     0,     5,    28,    29,    30,    31,    33,
      24,    29,    32,    10,    17,    34,    38,    39,    18,    12,
      11,    13,     5,    35,    36,    41,    17,    24,    15,     5,
      30,    40,    16,    24,    42,    37,     4,     6,     7,     8,
      11,    24,    43,    44,    45,    46,    49,    50,    36,    12,
      12,    12,    12,    18,    21,    23,    24,    52,    53,    54,
      55,    42,    10,    22,     9,    52,    52,    24,    52,    55,
      55,    10,    12,    14,    19,    21,    20,    14,    52,    52,
      12,    15,    15,    15,    15,    52,    56,    53,    54,    55,
      13,    17,    52,    47,    17,    17,    13,    52,    57,    58,
      22,    15,    43,    16,    15,    52,    51,    48,    58,    17,
      43,     3,    43
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 50 "asin.y"
    { dvar = 0; si = 0; carga_contexto(GLOBAL);

           /******************** Reserva de espacio para variables globales */
           arg1 = arg2 = cr_arg_nulo();
           res  = cr_arg_entero(-1);
           (yyval.ref).ref1 = crea_lans(si);  
           emite(INCTOP, arg1, arg2, res);
           /************************ Salto al comienzo de la funcion "main" */
           arg1 = arg2 = cr_arg_nulo();
           res  = cr_arg_etiqueta(-1);
           (yyval.ref).ref2 = crea_lans(si); 
           emite(CALL, arg1, arg2, res);
           res = cr_arg_nulo();
           emite(FIN, arg1, arg2,res);
         ;}
    break;

  case 3:
#line 68 "asin.y"
    { 
           if ((yyvsp[(2) - (2)].aux) == 0) yyerror ("Error: el programa no tiene `main'");  
           /***** Completa la reserva de espacio para las variables globales */
           res = cr_arg_entero(dvar);
           completa_lans((yyvsp[(1) - (2)].ref).ref1, res);
           /************* Completa el salto al comienzo de la funcion "main" */
           res = cr_arg_etiqueta((yyvsp[(2) - (2)].aux));
           completa_lans((yyvsp[(1) - (2)].ref).ref2, res);

           if (verbosidad) mostrar_tds();
           descarga_contexto(GLOBAL);
         ;}
    break;

  case 4:
#line 85 "asin.y"
    { (yyval.aux) = (yyvsp[(1) - (1)].aux); ;}
    break;

  case 5:
#line 89 "asin.y"
    { if ((yyvsp[(1) - (2)].aux) == 0)      (yyval.aux) = (yyvsp[(2) - (2)].aux);
	   else if ((yyvsp[(2) - (2)].aux) == 0) (yyval.aux) = (yyvsp[(1) - (2)].aux);
                else yyerror ("Error: el programa tiene mas de un `main'");
	 ;}
    break;

  case 6:
#line 98 "asin.y"
    { (yyval.aux) = 0; ;}
    break;

  case 7:
#line 102 "asin.y"
    { (yyval.aux) = (yyvsp[(1) - (1)].aux); ;}
    break;

  case 8:
#line 108 "asin.y"
    {
           if (!inserta_simbolo((yyvsp[(2) - (3)].ident),VARIABLE,T_ENTERO,dvar,contexto,-1))
             yyerror ("Identificador repetido");  
           dvar += TALLA_ENTERO;
         ;}
    break;

  case 9:
#line 116 "asin.y"
    {
           if ((yyvsp[(4) - (6)].ent) <= 0) yyerror("Error en la talla del array");
           if (!inserta_simbolo((yyvsp[(2) - (6)].ident),VARIABLE,T_ARRAY,dvar,contexto, 
			      inserta_info_array(T_ENTERO, (yyvsp[(4) - (6)].ent))))
             yyerror ("Identificador repetido");  
           dvar += (yyvsp[(4) - (6)].ent) * TALLA_ENTERO;
         ;}
    break;

  case 10:
#line 128 "asin.y"
    {  (yyval.aux) = dvar; dvar = 0;  ;}
    break;

  case 11:
#line 132 "asin.y"
    { 
           (yyval.aux) = (yyvsp[(1) - (3)].aux);
           if (verbosidad) mostrar_tds(); 
           dvar = (yyvsp[(2) - (3)].aux); descarga_contexto(LOCAL);  
         ;}
    break;

  case 12:
#line 142 "asin.y"
    { 
           carga_contexto(LOCAL); dpar = TALLA_SEGENLACES;
         ;}
    break;

  case 13:
#line 148 "asin.y"
    {
           if (!inserta_simbolo((yyvsp[(2) - (6)].ident),FUNCION,T_ENTERO,si,GLOBAL,(yyvsp[(5) - (6)].aux)))
             yyerror ("Identificador repetido");
           if (!strcmp((yyvsp[(2) - (6)].ident),"main")) (yyval.aux) = si; else (yyval.aux) = 0;
         ;}
    break;

  case 14:
#line 158 "asin.y"
    { (yyval.aux) = inserta_info_dominio(-1, T_VACIO); ;}
    break;

  case 15:
#line 162 "asin.y"
    { (yyval.aux) = (yyvsp[(1) - (1)].aux); ;}
    break;

  case 16:
#line 168 "asin.y"
    {
           dpar += TALLA_ENTERO;
           if (!inserta_simbolo((yyvsp[(2) - (2)].ident),PARAMETRO,T_ENTERO,-dpar,contexto,-1))
             yyerror ("Identificador repetido");    
           (yyval.aux) = inserta_info_dominio(-1, T_ENTERO);
         ;}
    break;

  case 17:
#line 177 "asin.y"
    {
           dpar += TALLA_ENTERO;
           if (!inserta_simbolo((yyvsp[(2) - (3)].ident),PARAMETRO,T_ENTERO,-dpar,contexto,-1))
             yyerror ("Identificador repetido");    
         ;}
    break;

  case 18:
#line 185 "asin.y"
    {
           (yyval.aux) = inserta_info_dominio((yyvsp[(5) - (5)].aux), T_ENTERO);
         ;}
    break;

  case 19:
#line 191 "asin.y"
    { /*******************************  Carga de los enlaces de control */
           arg1 = arg2 = cr_arg_nulo();
           res = cr_arg_entero(contexto);
           emite(PUSHFP, arg1, arg2, res);
           emite(FPTOP, arg1, arg2, res);
         ;}
    break;

  case 20:
#line 200 "asin.y"
    { /********* Reserva de espacio para Variables locales y temporales */
           arg1 = arg2 = cr_arg_nulo();
           res = cr_arg_entero(0);
           (yyval.aux) = crea_lans(si);
           emite(INCTOP, arg1, arg2, res);
         ;}
    break;

  case 21:
#line 209 "asin.y"
    { INF x;

           /********* Completa la reserva de espacios para variables locales */
           res = cr_arg_entero(dvar);    
           completa_lans((yyvsp[(4) - (8)].aux), res); 

	   x=obtener_info_funcion(-1); 
           if (((yyvsp[(7) - (8)].expre).tipo != x.tipo))
             yyerror("Error de tipos en la expresion del `return'");

           /*************************************** guardar valor de retorno */
           res = cr_arg_posicion(contexto,-(x.tparam+3));
           arg2 = cr_arg_nulo();
           emite(EASIG, (yyvsp[(7) - (8)].expre).pos, arg2, res);
  
           /*********** Libera el segmento de variables locales y temporales */
           arg1 = arg2 = cr_arg_nulo();
           res = cr_arg_entero(contexto);
           emite(TOPFP, arg1, arg2, res);

           /***************************** Descarga de los enlaces de control */
           emite(FPPOP, arg1, arg2, res);
           /****************** Emite la instruccion RETURN */
             arg1 = arg2 = res = cr_arg_nulo();
             emite(RET, arg1, arg2, res);
	 ;}
    break;

  case 31:
#line 258 "asin.y"
    { SIMB sim; int k;

           if ((k= busca_id((yyvsp[(1) - (4)].ident))) < 0)
             yyerror("Identificador no declarado");
	   else sim = obtener_simbolo(k);
	   if (sim.tipo != (yyvsp[(3) - (4)].expre).tipo)
             yyerror("Error de tipos en la asignacion");
           switch (sim.categoria) {
           case VARIABLE:
             res = cr_arg_posicion(sim.nivel, sim.desp);
             break;
           case PARAMETRO:
             res = cr_arg_posicion(sim.nivel, sim.desp);
             break;
           case FUNCION:
             yyerror("Error: asignacion a una funcion");
             break;
           }
           /*************************************** Asignaciones elementales */
           switch ((yyvsp[(2) - (4)].ent)) {
           case ASIG:
             arg2 = cr_arg_nulo();
             emite(EASIG, (yyvsp[(3) - (4)].expre).pos, arg2, res);
             break;
           case MASASIG:
	     emite(ESUM, res, (yyvsp[(3) - (4)].expre).pos, res);
             break;
           case MENOSASIG:
	     emite(EDIF, res, (yyvsp[(3) - (4)].expre).pos, res);
             break;
           }
         ;}
    break;

  case 32:
#line 293 "asin.y"
    { SIMB sim; DIM d; int k;

           if ((k= busca_id((yyvsp[(1) - (7)].ident))) < 0)
             yyerror("Identificador no declarado");
           else sim = obtener_simbolo(k);
           if ((sim.categoria != VARIABLE) || (sim.tipo != T_ARRAY))
             yyerror("El identificador debe ser una variable de tipo array");
           if ((yyvsp[(3) - (7)].expre).tipo != T_ENTERO)
              yyerror("El indice del array debe ser un entero");
           d = obtener_array(sim.ref);
           if ((yyvsp[(6) - (7)].expre).tipo != d.tipo)
             yyerror("Error de tipos en la asignacion");
           /*************************** Asignacion a un elemento de un array */
           arg1 = cr_arg_posicion(sim.nivel, sim.desp);
           switch ((yyvsp[(5) - (7)].ent)) {
           case ASIG:
             emite(EVA, arg1, (yyvsp[(3) - (7)].expre).pos, (yyvsp[(6) - (7)].expre).pos);
             break;
           case MASASIG:
	     res = cr_arg_posicion(contexto, crea_var_temp());
             emite(EAV, arg1, (yyvsp[(3) - (7)].expre).pos, res);
	     emite(ESUM, res, (yyvsp[(6) - (7)].expre).pos, res);
             emite(EVA, arg1, (yyvsp[(3) - (7)].expre).pos, res);
             break;
           case MENOSASIG:
	     res = cr_arg_posicion(contexto, crea_var_temp());
             emite(EAV, arg1, (yyvsp[(3) - (7)].expre).pos, res);
	     emite(EDIF, res, (yyvsp[(6) - (7)].expre).pos, res);
             emite(EVA, arg1, (yyvsp[(3) - (7)].expre).pos, res);
             break;
           }
         ;}
    break;

  case 33:
#line 330 "asin.y"
    { SIMB sim; int k;

           if ((k= busca_id((yyvsp[(3) - (5)].ident))) < 0)
             yyerror("Identificador no declarado");
	   else sim = obtener_simbolo(k);
           if ((sim.categoria!=VARIABLE)&&(sim.tipo != T_ENTERO)) 
             yyerror("Debe ser una variable de tipo entero");
           /**************************************** Lectura de una variable */
           arg1 = arg2 = cr_arg_nulo();
           res = cr_arg_posicion(sim.nivel, sim.desp);
           emite(EREAD, arg1, arg2, res);
         ;}
    break;

  case 34:
#line 345 "asin.y"
    {
           if ((yyvsp[(3) - (5)].expre).tipo != T_ENTERO) 
             yyerror("El argumento del `write' debe ser entero");
           /************************************* Escritura de una expresion */
           arg1 = arg2 = cr_arg_nulo();
           emite(EWRITE, arg1, arg2, (yyvsp[(3) - (5)].expre).pos);
         ;}
    break;

  case 35:
#line 357 "asin.y"
    {
           if ((yyvsp[(3) - (4)].expre).tipo != T_LOGICO)
             yyerror("La condicion debe ser de tipo logico");
           /********************************************** Salto condicional */
           arg2 = cr_arg_entero(0);
           res  = cr_arg_etiqueta(-1);
           (yyval.aux) = crea_lans(si);
           emite(EIGUAL, (yyvsp[(3) - (4)].expre).pos, arg2, res);
         ;}
    break;

  case 36:
#line 369 "asin.y"
    { 
           res = cr_arg_etiqueta(si+1); 
           completa_lans((yyvsp[(5) - (6)].aux), res);
           /******************************************** Salto incondicional */
           arg1 = arg2 = cr_arg_nulo();
           res  = cr_arg_etiqueta(-1);
           (yyval.aux)  = crea_lans(si);
           emite(GOTOS, arg1, arg2, res);
         ;}
    break;

  case 37:
#line 381 "asin.y"
    {
           res = cr_arg_etiqueta(si); 
           completa_lans((yyvsp[(7) - (9)].aux), res);
	 ;}
    break;

  case 38:
#line 388 "asin.y"
    { (yyval.aux) = si; ;}
    break;

  case 39:
#line 392 "asin.y"
    {
           if ((yyvsp[(4) - (5)].expre).tipo != T_LOGICO)
             yyerror("La condicion debe ser de tipo logico");
           /********************************************** Salto condicional */
           arg2 = cr_arg_entero(0); res  = cr_arg_etiqueta(-1);
           (yyval.aux) = crea_lans(si);
           emite(EIGUAL, (yyvsp[(4) - (5)].expre).pos, arg2, res);
	 ;}
    break;

  case 40:
#line 403 "asin.y"
    { /******************************************** Salto incondicional */
           arg1 = arg2 = cr_arg_nulo();
           res  = cr_arg_etiqueta((yyvsp[(1) - (7)].aux));
           emite(GOTOS, arg1, arg2, res);
           /******************************** Completa el salto incondicional */
           res = cr_arg_etiqueta(si); 
           completa_lans((yyvsp[(6) - (7)].aux), res);
         ;}
    break;

  case 41:
#line 416 "asin.y"
    { (yyval.expre) = (yyvsp[(1) - (1)].expre); ;}
    break;

  case 42:
#line 420 "asin.y"
    { int codop; (yyval.expre).tipo = T_ERROR;

           if (((yyvsp[(1) - (3)].expre).tipo != T_ENTERO) || ((yyvsp[(3) - (3)].expre).tipo != T_ENTERO))
             yyerror("Los operandos deben ser enteros");
           (yyval.expre).tipo = T_LOGICO;
	   (yyval.expre).pos = cr_arg_posicion(contexto, crea_var_temp());
           switch((yyvsp[(2) - (3)].ent)){
             case DISTINTO:    codop = EDIST;  break;
             case IGUAL:       codop = EIGUAL; break;
             case MAYOR:       codop = EMAY;   break;
             case MENOR:       codop = EMEN;   break;
             case MAYORIG:     codop = EMAYEQ; break;
             case MENORIG:     codop = EMENEQ; break;
             default:                          break;
           }
           /*********************************************** Expresion = TRUE */
           arg1 = cr_arg_entero(1);
           arg2 = cr_arg_nulo();
           emite(EASIG, arg1, arg2, (yyval.expre).pos);
           /************************************** Salto condicional si TRUE */
           res  = cr_arg_etiqueta(si+2);
           emite(codop, (yyvsp[(1) - (3)].expre).pos, (yyvsp[(3) - (3)].expre).pos, res);
           /********************************************** Expresion = FALSE */
           arg1 = cr_arg_entero(0);
           emite(EASIG, arg1, arg2, (yyval.expre).pos);
         ;}
    break;

  case 43:
#line 451 "asin.y"
    { (yyval.expre) = (yyvsp[(1) - (1)].expre); ;}
    break;

  case 44:
#line 455 "asin.y"
    { int codop; (yyval.expre).tipo = T_ERROR;

           if (((yyvsp[(1) - (3)].expre).tipo != T_ENTERO) || ((yyvsp[(3) - (3)].expre).tipo != T_ENTERO))
             yyerror("Error de tipo en la `exprisin simple'");
           (yyval.expre).tipo = T_ENTERO;
           (yyval.expre).pos = cr_arg_posicion(contexto, crea_var_temp());
           /***************** Expresion a partir de un operador aritmetico */
           emite((yyvsp[(2) - (3)].ent), (yyvsp[(1) - (3)].expre).pos, (yyvsp[(3) - (3)].expre).pos, (yyval.expre).pos);
         ;}
    break;

  case 45:
#line 469 "asin.y"
    { (yyval.expre) = (yyvsp[(1) - (1)].expre); ;}
    break;

  case 46:
#line 473 "asin.y"
    { int codop; (yyval.expre).tipo = T_ERROR;

           if (((yyvsp[(1) - (3)].expre).tipo != T_ENTERO) || ((yyvsp[(3) - (3)].expre).tipo != T_ENTERO))
             yyerror("Error de tipo en `termino'");
           (yyval.expre).tipo = T_ENTERO;
           (yyval.expre).pos = cr_arg_posicion(contexto, crea_var_temp());
            /***************** Expresion a partir de un operador aritmetico */
           emite((yyvsp[(2) - (3)].ent), (yyvsp[(1) - (3)].expre).pos, (yyvsp[(3) - (3)].expre).pos, (yyval.expre).pos);
         ;}
    break;

  case 47:
#line 487 "asin.y"
    { SIMB sim; int k;

           if ((k= busca_id((yyvsp[(1) - (1)].ident))) < 0) {
             (yyval.expre).tipo = T_ERROR;
             yyerror("Identificador no declarado");
	   }
	   else {sim = obtener_simbolo(k);
                 (yyval.expre).tipo = sim.tipo;
	   }
           switch (sim.categoria) {
           case VARIABLE: 
             (yyval.expre).pos = cr_arg_posicion(sim.nivel, sim.desp);
             break;
           case PARAMETRO:
             (yyval.expre).pos = cr_arg_posicion(sim.nivel, sim.desp);
             break;
           case FUNCION:
             yyerror("Error en la sintaxis de la llamada a la funcion");
             break;
           }
         ;}
    break;

  case 48:
#line 511 "asin.y"
    {
           (yyval.expre).tipo = T_ENTERO;
           (yyval.expre).pos = cr_arg_entero((yyvsp[(1) - (1)].ent));    
         ;}
    break;

  case 49:
#line 518 "asin.y"
    {
           (yyval.expre).tipo = (yyvsp[(2) - (2)].expre).tipo;
           if ((yyvsp[(1) - (2)].ent) == MENOS) {
             if (((yyvsp[(1) - (2)].ent) == MENOS)&&((yyval.expre).tipo == T_ENTERO)) {
               /*************************** Cambio de signo en caso de MENOS */
               arg2 = cr_arg_nulo();   
               (yyval.expre).pos = cr_arg_posicion(contexto, crea_var_temp());
               emite(ESIG, (yyvsp[(2) - (2)].expre).pos, arg2, (yyval.expre).pos);
               }
             else yyerror("Error de tipo en `factor'");
             }
           else (yyval.expre).pos = (yyvsp[(2) - (2)].expre).pos;
         ;}
    break;

  case 50:
#line 533 "asin.y"
    {
           (yyval.expre).tipo = (yyvsp[(2) - (2)].expre).tipo;
           if ((yyval.expre).tipo != T_ENTERO)
             yyerror("Error de tipo en `factor'");
	   /******************************* Cambio de signo en caso de MENOS */
           arg2 = cr_arg_entero(1);
           (yyval.expre).pos = cr_arg_posicion(contexto, crea_var_temp());
           emite((yyvsp[(1) - (2)].ent), (yyvsp[(2) - (2)].expre).pos, arg2, (yyvsp[(2) - (2)].expre).pos);
           arg2 = cr_arg_nulo();
           emite(EASIG, (yyvsp[(2) - (2)].expre).pos, arg2, (yyval.expre).pos);
         ;}
    break;

  case 51:
#line 547 "asin.y"
    { (yyval.expre) = (yyvsp[(2) - (3)].expre);;}
    break;

  case 52:
#line 551 "asin.y"
    { 
           SIMB sim; DIM d; int k;

           if ((k= busca_id((yyvsp[(1) - (4)].ident))) < 0)
             yyerror("Identificador no declarado");
           else sim = obtener_simbolo(k);
           if ((sim.categoria != VARIABLE) || (sim.tipo != T_ARRAY))
             yyerror("El identificador debe ser una variable de tipo array");
           if ((yyvsp[(3) - (4)].expre).tipo != T_ENTERO)
              yyerror("El indice del array debe ser un entero");
           d = obtener_array(sim.ref);
           /**************************** Expresion como elemento de un array */
           arg1 = cr_arg_posicion(sim.nivel, sim.desp);
           (yyval.expre).tipo = d.tipo;
           (yyval.expre).pos  = cr_arg_posicion(contexto, crea_var_temp());
           emite(EAV, arg1, (yyvsp[(3) - (4)].expre).pos, (yyval.expre).pos);
         ;}
    break;

  case 53:
#line 571 "asin.y"
    { /*********************** Reserva espacio para el valor de retorno */
           arg1 = arg2 = cr_arg_nulo();
           res  = cr_arg_entero(0);
           emite(EPUSH,arg2,arg2,res);
	 ;}
    break;

  case 54:
#line 579 "asin.y"
    { SIMB sim; int k; INF x;

           if ((k= busca_id((yyvsp[(1) - (5)].ident))) < 0)
             yyerror("Identificador no declarado");
	   else sim = obtener_simbolo(k);
           if (sim.categoria != FUNCION) 
            yyerror("La variable no es una funcion");
	   x=obtener_info_funcion(k); 
           if (!compara_dominio(sim.ref, (yyvsp[(4) - (5)].aux)))
            yyerror("Error en el dominio de parametros actuales");
           /******************************************* Llamada a la funcion */
           arg1 = arg2 = cr_arg_nulo();
           res = cr_arg_etiqueta(sim.desp);
           emite(CALL, arg1, arg2, res);
           /***************************** Desapila el segmento de parametros */
           res = cr_arg_entero(x.tparam);
           emite(DECTOP, arg1, arg2, res);
           /************************** Desapila y asigna el valor de retorno */
           (yyval.expre).tipo = sim.tipo;
	   (yyval.expre).pos  = cr_arg_posicion(contexto, crea_var_temp());
           emite(EPOP, arg1, arg2, (yyval.expre).pos);
         ;}
    break;

  case 55:
#line 606 "asin.y"
    { (yyval.aux) = inserta_info_dominio(-1, T_VACIO); ;}
    break;

  case 56:
#line 610 "asin.y"
    { (yyval.aux) = (yyvsp[(1) - (1)].aux); ;}
    break;

  case 57:
#line 616 "asin.y"
    {
           if (((yyvsp[(1) - (1)].expre).tipo != T_ENTERO) && ((yyvsp[(1) - (1)].expre).tipo != T_LOGICO)) 
             yyerror("El tipo de los parametros debe ser de tipo simple");
           (yyval.aux) = inserta_info_dominio(-1, (yyvsp[(1) - (1)].expre).tipo);
           /************************************** Apila el parametro actual */
           arg1 =  arg2 = cr_arg_nulo();
           emite(EPUSH, arg1, arg2, (yyvsp[(1) - (1)].expre).pos);
         ;}
    break;

  case 58:
#line 627 "asin.y"
    {
           if (((yyvsp[(1) - (3)].expre).tipo != T_ENTERO) && ((yyvsp[(1) - (3)].expre).tipo != T_LOGICO)) 
             yyerror("El tipo de los parametros debe ser de tipo simple");
           (yyval.aux) = inserta_info_dominio((yyvsp[(3) - (3)].aux), (yyvsp[(1) - (3)].expre).tipo);
           /************************************** Apila el parametro actual */
           arg1 =  arg2 = cr_arg_nulo();
           emite(EPUSH, arg1, arg2, (yyvsp[(1) - (3)].expre).pos);
         ;}
    break;


/* Line 1267 of yacc.c.  */
#line 2052 "asin-yac.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 637 "asin.y"

/******************************************************************************
******************************************************************************/

