#ifndef DEFINICIONES_H
#define DEFINICIONES_H

#define MAXCODE    500       /* Talla maxima del segmento de instrucciones        */
#define MAXMEM    1000       /* Talla maxima del segmento de memoria              */
#define MAXERR    2000       /* Longitud maxima de los mensajes de error de carga */
#define NOMBRES << "NULO" << "ESUM" << "RSUM" << "EDIF" << "RDIF" << "EMULT" << "RMULT" << "EDIVI" << "RDIVI" << "RESTO" << "CONV" << "TRUNC" << "ESIG" << "RSIG" << "EASIG" << "RASIG" << "GOTOS" << "EIGUAL" << "RIGUAL" << "EDIST" << "RDIST" << "EMEN" << "RMEN" << "EMAY" << "RMAY" << "EMAYEQ" << "RMAYEQ" << "EMENEQ" << "RMENEQ" << "EAV" << "RAV" << "EVA" << "RVA" << "EREAD" << "RREAD" << "EWRITE" << "RWRITE" << "CREAD" << "CWRITE" << "FIN" << "RET" << "CALL" << "NOP" << "EPUSH" << "RPUSH" << "EPOP" << "RPOP" << "PUSHFP" << "FPPOP" << "FPTOP" << "TOPFP" << "INCTOP" << "DECTOP"
#define MAXERRVEC   10

enum t_cod_ins {NULO = 0, ESUM, RSUM, EDIF, RDIF, EMULT, RMULT, EDIVI, RDIVI, RESTO, CONV,
               TRUNC, ESIG, RSIG, EASIG, RASIG, GOTOS, EIGUAL, RIGUAL, EDIST,
               RDIST, EMEN, RMEN, EMAY, RMAY, EMAYEQ, RMAYEQ, EMENEQ, RMENEQ,
               EAV, RAV, EVA, RVA, EREAD, RREAD, EWRITE, RWRITE, CREAD, CWRITE,
               FIN, RET, CALL, NOP, EPUSH, RPUSH, EPOP, RPOP, PUSHFP, FPPOP,
               FPTOP, TOPFP, INCTOP, DECTOP};

enum t_cod_arg {ARG_NULO = 0, ARG_ENTERO, ARG_REAL, ARG_POSICION, ARG_ETIQUETA};

enum tipo_mem {MEM_UNUSED = 0, MEM_INT, MEM_REAL, MEM_FP, MEM_DEST_S};

enum error_mem {NO_ERROR = 0, ERROR_VACIA, ERROR_NOEXISTE, ERROR_TIPO, ERROR_ARG, ERROR_SUP_TOP, ERROR_CWRITE, ERROR_DIV_CERO};

struct tipo_arg { int tipo, i_pos, niv; float r; };

struct tipo_ctd { int lin, cop; struct tipo_arg arg[3]; };

#endif
